-- name: [CS] The Herd Pack
-- description: The official CS pack for the Herd, created for @StrikerDeer on Youtube

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_STRIKER = smlua_model_util_get_id("striker_geo")
local E_MODEL_WABBIT = smlua_model_util_get_id("wab_geo")
local E_MODEL_BEANS = smlua_model_util_get_id("beans_geo")
local E_MODEL_CTNEW = smlua_model_util_get_id("ctnew_geo")

local TEX_STRIKER = get_texture_info("striker-icon")
local TEX_WABBIT = get_texture_info("wab-icon")
local TEX_BEANS = get_texture_info("beans-icon")
local TEX_CTNEW = get_texture_info("ctnew-icon")

local TEXT_MOD_NAME = "The Herd Pack"

local VOICETABLE_STRIKER = {
    [CHAR_SOUND_ATTACKED] = 'striker_uhn hit.ogg',
    [CHAR_SOUND_DOH] = 'striker_uhn hit.ogg',
    [CHAR_SOUND_DROWNING] = 'striker_drowning.ogg',
    [CHAR_SOUND_DYING] = 'striker_dying.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'striker_wahgroundpound.ogg',
    [CHAR_SOUND_HAHA] = 'striker_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'striker_haha2.ogg',
    [CHAR_SOUND_HRMM] = 'striker_hrrmmpphh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'striker_wowie.ogg',
    [CHAR_SOUND_HOOHOO] = 'striker_wah.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'striker_mamamia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'striker_okeydokey.ogg',
    [CHAR_SOUND_ON_FIRE] = 'striker_onfire.ogg',
    [CHAR_SOUND_OOOF] = 'striker_oof1.ogg',
    [CHAR_SOUND_OOOF2] = 'striker_oof2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'striker_hoopunch.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'striker_wahpunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'striker_yahpunch.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'striker_solongabowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'striker_wowie.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'striker_waaaaaaaaow.ogg',
    [CHAR_SOUND_WAH2] = 'striker_wah.ogg',
    [CHAR_SOUND_WHOA] = 'striker_woah.ogg',
    [CHAR_SOUND_YAHOO] = 'striker_yipee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'striker_yipee.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'striker_yah.ogg',
    [CHAR_SOUND_YAWNING] = 'striker_yawn.ogg',
}

local VOICETABLE_CTNEW = {
    [CHAR_SOUND_ATTACKED] = 'CT_Attacked.ogg',
    [CHAR_SOUND_DOH] = 'CT_Doh.ogg',
    [CHAR_SOUND_DROWNING] = 'CT_Drowning.ogg',
    [CHAR_SOUND_DYING] = 'CT_Dying.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'CT_WahGroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'CT_Haha1.ogg',
    [CHAR_SOUND_HAHA_2] = 'CT_haha2.ogg',
    [CHAR_SOUND_HRMM] = 'CT_pickup.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'CT_HereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'CT_Hoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'CT_Mamamia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'CT_OkeyDokey.ogg',
    [CHAR_SOUND_ON_FIRE] = 'CT_OnFire.ogg',
    [CHAR_SOUND_OOOF] = 'CT_Oof1.ogg',
    [CHAR_SOUND_OOOF2] = 'CT_Oof2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'CT_Hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'CT_WahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'CT_YahPunch.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'CT_SoLongKingBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'CT_Boing.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'CT_OnFire.ogg',
    [CHAR_SOUND_WAH2] = 'CT_Wah2.ogg',
    [CHAR_SOUND_WHOA] = 'CT_Whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'CT_Yipee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'CT_Yipee.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'CT_YahPunch.ogg',
    [CHAR_SOUND_YAWNING] = 'CT_Yawn.ogg',
}

local VOICETABLE_WAB = {
    [CHAR_SOUND_ATTACKED] = 'Wab Lose Health.ogg',
    [CHAR_SOUND_DOH] = 'Wab Uhn.ogg',
    [CHAR_SOUND_DROWNING] = 'Wab Drowning.ogg',
    [CHAR_SOUND_DYING] = 'Wab Uhh Ooph.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Wab Wah.ogg',
    [CHAR_SOUND_HAHA] = 'Wab Haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Wab Haha.ogg',
    [CHAR_SOUND_HRMM] = 'Wab Uhn.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Wab Here we go.ogg',
    [CHAR_SOUND_HOOHOO] = 'Wab Hoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Wab Mamma Mia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Wab Its a me Mario.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Wab Hot hot hot.ogg',
    [CHAR_SOUND_OOOF] = 'Wab Ooph.ogg',
    [CHAR_SOUND_OOOF2] = 'Wab Uhn 02.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Wab Hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Wab Wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Wab Yah2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Wab Okey dokey.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Wab Yahoo.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Wab Wahhh.ogg',
    [CHAR_SOUND_WAH2] = 'Wab Wah.ogg',
    [CHAR_SOUND_WHOA] = 'Wab Ooh.ogg',
    [CHAR_SOUND_YAHOO] = 'Wab Yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Wab Yahoo.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'Wab Yah2.ogg',
    [CHAR_SOUND_YAWNING] = 'Wab Yawn.ogg',
}

local VOICETABLE_BEANS = {
    [CHAR_SOUND_ATTACKED] = 'beans_oof2.ogg',
    [CHAR_SOUND_DOH] = 'beans_oof1.ogg',
    [CHAR_SOUND_DROWNING] = 'beans_drown.ogg',
    [CHAR_SOUND_DYING] = 'Beans_death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'beans_ground_pound.ogg',
    [CHAR_SOUND_HAHA] = 'beans_haha!.ogg',
    [CHAR_SOUND_HAHA_2] = 'beans_haha! 2.ogg',
    [CHAR_SOUND_HRMM] = 'beans_hit.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'beans_star_get.ogg',
    [CHAR_SOUND_HOOHOO] = 'beans_wah.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'beans_mama_mia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'beans_okey_dokey.ogg',
    [CHAR_SOUND_ON_FIRE] = 'beans_burn.ogg',
    [CHAR_SOUND_OOOF] = 'beans_oof1.ogg',
    [CHAR_SOUND_OOOF2] = 'beans_oof2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'beans_punch3.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'beans_punch1.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'beans_punch2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'beans_so_long_sucka.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'beans_boing!.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'beans_burn.ogg',
    [CHAR_SOUND_WAH2] = 'beans_wah.ogg',
    [CHAR_SOUND_WHOA] = 'beans_woah.ogg',
    [CHAR_SOUND_YAHOO] = 'beans_yippee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'beans_yippee.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'beans_punch1.ogg',
    [CHAR_SOUND_YAWNING] = 'beans_yawn.ogg',
}






if _G.charSelectExists then
    CT_STRIKER = _G.charSelect.character_add("Striker", {"The Deer Boi himself"}, "CT Himself", {r = 184, g = 118, b = 73}, E_MODEL_STRIKER, CT_MARIO, TEX_STRIKER)
    CT_WABBIT = _G.charSelect.character_add("Wabbit", {"He lurks."}, "CT Himself", {r = 92, g = 90, b = 131}, E_MODEL_WABBIT, CT_MARIO, TEX_WABBIT)
    CT_BEANS = _G.charSelect.character_add("Beans", {"Fking hates Mystic"}, "CT Himself", {r = 255, g = 255, b = 255}, E_MODEL_BEANS, CT_MARIO, TEX_BEANS)
    CT_CTNEW = _G.charSelect.character_add("CT Himself", {"Oh boy, *another* CT model..."}, "CT Himself", {r = 223, g = 113, b = 38}, E_MODEL_CTNEW, CT_MARIO, TEX_CTNEW)

        -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_STRIKER, VOICETABLE_STRIKER)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_STRIKER then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_STRIKER then return _G.charSelect.voice.snore(m) end
        end)

                -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_CTNEW, VOICETABLE_CTNEW)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_CTNEW then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_CTNEW then return _G.charSelect.voice.snore(m) end
        end)

                        -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_WABBIT, VOICETABLE_WAB)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_WAB then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_WAB then return _G.charSelect.voice.snore(m) end
        end)

                                -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_BEANS, VOICETABLE_BEANS)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_BEANS then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_BEANS then return _G.charSelect.voice.snore(m) end
        end)

else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end